# -*- coding: utf-8 -*-
t='**********************************************'
x='# (C) Alexey S. Galitsky, Novosibirsk - 2020 #'
t='**********************************************'

import os
import time
import urllib
import httplib
from datetime import datetime

BOTNAME = 'SupBot'
VERSION = '1.0'

SLEEP	= 2
MAXATT	= 2
TIMEOUT	= 3
SLPMODE	= 60
OK		= 200
FORBIDD	= 403
NOTFND	= 404
SERVUN	= 503
PASSW	= 123456

def header():
	print '%s\r\n%s\r\n%s\r\n' % (t, x, t)
	print "Hi, I'm %s %s\r\n" % (BOTNAME, VERSION)

def sleep(sleep):
	time.sleep(sleep)

def inputCODE():
	while True:
		try:
			code = int(raw_input('Enter code: '))
			if code >= 123456:
				return code
			else:
				int('a')
		except:
			print 'ERROR: Code is not valid\r\n'
			sleep(SLEEP)

def inputPROVIDER():
	while True:
		provider = raw_input('Enter provider: ')
		if provider == '':
			print 'ERROR: Provider empty\r\n'
			sleep(SLEEP)
		else:
			print
			return provider.lower()

def namePLIST():
	namefile = os.listdir(os.getcwd())
	for name in namefile:
		if name.find('.m3u') != -1:
			return name
	print 'ERROR: Play list not found'
	sleep(SLEEP)
	exit()

def readPLIST():
	numb = 0
	newplist = []
	plistfile = open(namePLIST(), 'r')
	print 'INFO:  Read IPTV play list'
	for line in plistfile.readlines():
		newline = line.strip('\n')
		if len(newline) > 0:
			if (newline.find('/udp/') != -1 and numb == 0):
				numb += 1
				udpxyaddr = newline.split('/')[2]
			newplist.append(newline)
	plistfile.close()
	return newplist, udpxyaddr

def verifyUDPXY(udpxy):
	attempt = 0
	while attempt < MAXATT:
		try:
			connect = httplib.HTTPConnection(udpxy, timeout=TIMEOUT)
			connect.request('GET', '/status')
			gresponse = connect.getresponse()
			if gresponse.status == OK:
				return True
		except:
			attempt += 1
	return False

def verifyDATA(code, provider):
	attempt = 0
	urllib.socket.setdefaulttimeout(TIMEOUT)
	linkcode = 'https://proxybot.ru/iptv/php/vrfcode.php?code=%s' % code
	linkprvd = 'http://proxytv.ru/iptv/php/vrfprvd.php?provider=%s' % provider
	while attempt < MAXATT:
		try:
			getcode = int(urllib.urlopen(linkcode).read())
			getprvd = int(urllib.urlopen(linkprvd).read())
			if getcode != OK:
				print 'ERROR: Access denied'
				return False
			elif getprvd != OK:
				print 'ERROR: Provider not found'
				return False
			else:
				return True
		except:
			attempt += 1
	print 'ERROR: Service unavailable'
	exit()

def getUDPXY(code, provider):
	attempt = 0
	urllib.socket.setdefaulttimeout(TIMEOUT)
	print 'INFO:  Search source IPTV'
	linkudpxy = 'https://proxybot.ru/iptv/php/getudpxy.php?code=%s&provider=%s' % (code, provider)
	while attempt < MAXATT:
		try:
			newudpxy = urllib.urlopen(linkudpxy).read()
			try:
				return int(newudpxy)
			except:
				return newudpxy
		except:
			attempt += 1
	return SERVUN

def newPLIST(plist, udpxy):
	newplist = []
	for line in plist:
		if line.find('/udp/') == -1:
			newplist.append(line)
		else:
			addr = line.split('/')[2]
			line = line.replace(addr, udpxy)
			newplist.append(line)
	return newplist

def savePLIST(plist):
	try:
		plistfile = open(namePLIST(), 'w')
		for line in plist:
			plistfile.write(line + '\n')
		plistfile.close()
		return True
	except:
		return False

def startBOT():
	header()
	code = inputCODE()
	provider = inputPROVIDER()
	plist, udpxy = readPLIST()
	if not verifyDATA(code, provider):
		print 'INFO:  Demo mode. Provider "Aist"\r\n'
	else:
		print 'INFO:  Self-updating play list IPTV "%s"\r\n' % provider
	while True:
		print '*****', datetime.today().strftime('%d.%m.%Y in %H:%M'), '*****'
		if not verifyUDPXY(udpxy):
			udpxy = getUDPXY(code, provider)
			if udpxy == FORBIDD:
				print 'ERROR: Access denied'
			elif udpxy == NOTFND:
				print 'ERROR: Source IPTV not found'
			elif udpxy == SERVUN:
				print 'ERROR: Service unavailable'
			else:
				plist = newPLIST(plist, udpxy)
				if savePLIST(plist):
					print 'INFO:  Play list saved'
				else:
					print 'ERROR: Play list not saved'
		else:
			print 'INFO:  Play list working'
		print 'INFO:  Sleep mode %s sec\r\n' % SLPMODE
		sleep(SLPMODE)

startBOT()
